#!/usr/bin/env python
# -*- coding: utf-8 -*-

import RPi.GPIO as GPIO
from time import sleep
import time 
import datetime
import os
import sys
sys.path.append('/usr/local/lib/cpi3adc')
import cpi3x
from adc_value import *
#from adc_value2 import *

# TODO controllare se sono gi in esecuzione

fpid = os.fork()
if fpid==0:   # se sono il figlio continuo col mio lavoro

  pid = str(os.getpid())
  pidfile = "/var/run/cpi3adc.pid"
  
  file(pidfile, 'w').write(pid)
  
  GPIO.setmode(GPIO.BOARD)
  
  
  read=cpi3x.readanalog
  
  #print NUMERATORE
  
  i=0
  SUM1 = 0
  SUM2 = 0
  SUM3 = 0
  SUM4 = 0
  SUM5 = 0
  SUM6 = 0
  SUM7 = 0
  SUM8 = 0
  
  while True:
  
      out = "" 
      ADC1 = read(0)
      ADC2 = read(1)
      ADC3 = read(2)
      ADC4 = read(3)
      ADC5 = read(4)
      ADC6 = read(5)
      ADC7 = read(6)
      ADC8 = read(7)
      
      #print ADC1
  
      i+=1 # incrementiamo il nr di letture
      SUM1 += ADC1
      SUM2 += ADC2
      SUM3 += ADC3
      SUM4 += ADC4
      SUM5 += ADC5
      SUM6 += ADC6
      SUM7 += ADC7
      SUM8 += ADC8
      
      if i == MEDIA:
          ADC1 = SUM1 / MEDIA
          ADC2 = SUM2 / MEDIA
          ADC3 = SUM3 / MEDIA
          ADC4 = SUM4 / MEDIA
          ADC5 = SUM5 / MEDIA
          ADC6 = SUM6 / MEDIA
          ADC7 = SUM7 / MEDIA
          ADC8 = SUM8 / MEDIA
          
          
          Volt1 = ADC1*2.5/4096
          Volt2 = ADC2*2.5/4096
          Volt3 = ADC3*2.5/4096
          Volt4 = ADC4*2.5/4096
          Volt5 = ADC5*2.5/4096
          Volt6 = ADC6*2.5/4096
          Volt7 = ADC7*2.5/4096
          Volt8 = ADC8*2.5/4096
          
          IN1 = (ADC1*MOLT_IN1)
          IN2 = (ADC2*MOLT_IN2)
          IN3 = (ADC3*MOLT_IN3)
          IN4 = (ADC4*MOLT_IN4)
          IN5 = (ADC5*MOLT_IN5)
          IN6 = (ADC6*MOLT_IN6)
          IN7 = (ADC7*MOLT_IN7)        
          IN8 = (ADC8*MOLT_IN8)
          
          V1 = (float(ADC1) * NUM1 / DEN1) - OFF1
          V2 = (float(ADC2) * NUM2 / DEN2) - OFF2
          V3 = (float(ADC3) * NUM3 / DEN3) - OFF3
          V4 = (float(ADC4) * NUM4 / DEN4) - OFF4
          V5 = (float(ADC5) * NUM5 / DEN5) - OFF5
          V6 = (float(ADC6) * NUM6 / DEN6) - OFF6
          V7 = (float(ADC7) * NUM7 / DEN7) - OFF7
          V8 = (float(ADC8) * NUM8 / DEN8) - OFF8
          
          #print ADC1, V1,NUM1, DEN1
  
  
          
          ADC1 = str(ADC1)
          ADC2 = str(ADC2)
          ADC3 = str(ADC3)
          ADC4 = str(ADC4)
          ADC5 = str(ADC5)
          ADC6 = str(ADC6)
          ADC7 = str(ADC7)
          ADC8 = str(ADC8)
          
          Volt1 = str(round(Volt1,3))
          Volt2 = str(round(Volt2,3))
          Volt3 = str(round(Volt3,3))
          Volt4 = str(round(Volt4,3))
          Volt5 = str(round(Volt5,3))
          Volt6 = str(round(Volt6,3))
          Volt7 = str(round(Volt7,3))
          Volt8 = str(round(Volt8,3))
          
          IN1 = str(round(IN1,3))
          IN2 = str(round(IN2,3))
          IN3 = str(round(IN3,3))
          IN4 = str(round(IN4,3))
          IN5 = str(round(IN5,3))
          IN6 = str(round(IN6,3))
          IN7 = str(round(IN7,3))
          IN8 = str(round(IN8,3))
          
          V1 = str(round(V1,3))
          V2 = str(round(V2,3))
          V3 = str(round(V3,3))
          V4 = str(round(V4,3))
          V5 = str(round(V5,3))
          V6 = str(round(V6,3))
          V7 = str(round(V7,3))
          V8 = str(round(V8,3))
  
                     
          #print V2
          out_ADC = time.strftime('%Y%m%d%H%M%S',time.localtime())+","+ADC1+","+ADC2+","+ADC3+","+ADC4+","+ADC5+","+ADC6+","+ADC7+","+ADC8
          out_Volt = time.strftime('%Y%m%d%H%M%S',time.localtime())+","+Volt1+","+Volt2+","+Volt3+","+Volt4+","+Volt5+","+Volt6+","+Volt7+","+Volt8
          out_IN = time.strftime('%Y%m%d%H%M%S',time.localtime())+","+IN1+","+IN2+","+IN3+","+IN4+","+IN5+","+IN6+","+IN7+","+IN8
  
          out_Value = time.strftime('%Y%m%d%H%M%S',time.localtime())+","+V1+","+V2+","+V3+","+V4+","+V5+","+V6+","+V7+","+V8
          #print out
  
          #print "ADC - " + out_ADC
          #print "Volt - " + out_Volt 
          #print "IN - "  + out_IN 
          #print "Valori - " + out_Value
  
          with open("/var/www/adc/csv/adc.csv", 'a') as f:
              f.write(out_ADC+"\n")
          with open("/var/www/adc/csv/volt.csv", 'a') as f:
              f.write(out_Volt+"\n")
          with open("/var/www/adc/csv/in.csv", 'a') as f:
              f.write(out_IN+"\n")
          with open("/var/www/adc/csv/value.csv", 'a') as f:
              f.write(out_Value+"\n")
  
          # azzeriamo tutti i valori
          SUM1 = 0
          SUM2 = 0
          SUM3 = 0
          SUM4 = 0
          SUM5 = 0
          SUM6 = 0
          SUM7 = 0
          SUM8 = 0
          i = 0
  
  
      sleep (INTERVALLO)
      
  
  os.unlink(pidfile)


sys.exit(0);